## mingw-w64-krita-5.2.2-7.src.tar.zst

=== 3rdparty/ext_fcitx-qt/CMakeLists.txt ===
SET(EXTPREFIX_fcitx5-qt "${EXTPREFIX}" )

ExternalProject_Add(
    ext_fcitx5-qt
    DOWNLOAD_DIR ${EXTERNALS_DOWNLOAD_DIR}
    URL https://github.com/fcitx/fcitx5-qt/archive/refs/tags/5.1.3.tar.gz
    URL_HASH SHA256=fbf5060e94632cdb80cbe8352c217821ebf7bb961b057ab34153f5e53290109e

    SOURCE_DIR fcitx5-qt-5.1.3
    INSTALL_DIR ${EXTPREFIX_fcitx5-qt}
    CMAKE_ARGS -DCMAKE_INSTALL_PREFIX=${EXTPREFIX_fcitx5-qt} -DCMAKE_BUILD_TYPE=${GLOBAL_BUILD_TYPE} ${GLOBAL_PROFILE} -DENABLE_QT4=OFF -DENABLE_QT5=ON -DENABLE_QT6=OFF -DBUILD_ONLY_PLUGIN=ON

    DEPENDS ${QT_DEP}
    UPDATE_COMMAND ""
)
